module CGRA_configurator(
    input      clock,
    input      enable,
    input      sync_reset,

    output reg bitstream,
    output reg done
);

    localparam TOTAL_NUM_BITS = 896;
	reg [0:TOTAL_NUM_BITS-1] storage = {
		1'bx, // rf_c3_r3::rf_c3_r3Reg1Config
		1'b1, // rf_c3_r3::rf_c3_r3Reg0Config
		1'b0, // rf_c3_r3::rf_c3_r3OutMux1Config
		1'bx, // rf_c3_r3::rf_c3_r3OutMux0Config
		1'bx, // rf_c3_r2::rf_c3_r2Reg1Config
		1'b1, // rf_c3_r2::rf_c3_r2Reg0Config
		1'b0, // rf_c3_r2::rf_c3_r2OutMux1Config
		1'bx, // rf_c3_r2::rf_c3_r2OutMux0Config
		1'bx, // rf_c3_r1::rf_c3_r1Reg1Config
		1'b1, // rf_c3_r1::rf_c3_r1Reg0Config
		1'b0, // rf_c3_r1::rf_c3_r1OutMux1Config
		1'bx, // rf_c3_r1::rf_c3_r1OutMux0Config
		1'bx, // rf_c2_r3::rf_c2_r3Reg1Config
		1'b1, // rf_c2_r3::rf_c2_r3Reg0Config
		1'b0, // rf_c2_r3::rf_c2_r3OutMux1Config
		1'b0, // rf_c2_r3::rf_c2_r3OutMux0Config
		1'bx, // rf_c2_r2::rf_c2_r2Reg1Config
		1'bx, // rf_c2_r2::rf_c2_r2Reg0Config
		1'bx, // rf_c2_r2::rf_c2_r2OutMux1Config
		1'bx, // rf_c2_r2::rf_c2_r2OutMux0Config
		1'b1, // rf_c2_r1::rf_c2_r1Reg1Config
		1'b1, // rf_c2_r1::rf_c2_r1Reg0Config
		1'b1, // rf_c2_r1::rf_c2_r1OutMux1Config
		1'b0, // rf_c2_r1::rf_c2_r1OutMux0Config
		1'bx, // rf_c1_r3::rf_c1_r3Reg1Config
		1'bx, // rf_c1_r3::rf_c1_r3Reg0Config
		1'bx, // rf_c1_r3::rf_c1_r3OutMux1Config
		1'bx, // rf_c1_r3::rf_c1_r3OutMux0Config
		1'bx, // rf_c1_r2::rf_c1_r2Reg1Config
		1'b1, // rf_c1_r2::rf_c1_r2Reg0Config
		1'b0, // rf_c1_r2::rf_c1_r2OutMux1Config
		1'bx, // rf_c1_r2::rf_c1_r2OutMux0Config
		1'bx, // rf_c1_r1::rf_c1_r1Reg1Config
		1'bx, // rf_c1_r1::rf_c1_r1Reg0Config
		1'bx, // rf_c1_r1::rf_c1_r1OutMux1Config
		1'bx, // rf_c1_r1::rf_c1_r1OutMux0Config
		1'bx, // rf_c0_r3::rf_c0_r3Reg1Config
		1'b1, // rf_c0_r3::rf_c0_r3Reg0Config
		1'b0, // rf_c0_r3::rf_c0_r3OutMux1Config
		1'bx, // rf_c0_r3::rf_c0_r3OutMux0Config
		1'bx, // rf_c0_r2::rf_c0_r2Reg1Config
		1'b1, // rf_c0_r2::rf_c0_r2Reg0Config
		1'b0, // rf_c0_r2::rf_c0_r2OutMux1Config
		1'bx, // rf_c0_r2::rf_c0_r2OutMux0Config
		1'bx, // rf_c0_r1::rf_c0_r1Reg1Config
		1'b1, // rf_c0_r1::rf_c0_r1Reg0Config
		1'b0, // rf_c0_r1::rf_c0_r1OutMux1Config
		1'bx, // rf_c0_r1::rf_c0_r1OutMux0Config
		1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c3_r3::ConstVal
		1'b0, // pe_c3_r3::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c3_r3::MuxBypassConfig
		1'b1,1'b0,1'b0, // pe_c3_r3::MuxBConfig
		1'b0,1'b1,1'b1, // pe_c3_r3::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c3_r3::FuncConfig
		1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c3_r2::ConstVal
		1'b0, // pe_c3_r2::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c3_r2::MuxBypassConfig
		1'b1,1'b0,1'b1,1'b0, // pe_c3_r2::MuxBConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c3_r2::MuxAConfig
		1'b1,1'b0,1'b0,1'b0, // pe_c3_r2::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c3_r1::ConstVal
		1'b0, // pe_c3_r1::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c3_r1::MuxBypassConfig
		1'b0,1'b0,1'b1,1'b0, // pe_c3_r1::MuxBConfig
		1'b1,1'b0,1'b0,1'b0, // pe_c3_r1::MuxAConfig
		1'b1,1'b0,1'b0,1'b0, // pe_c3_r1::FuncConfig
		1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c3_r0::ConstVal
		1'b0, // pe_c3_r0::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c3_r0::MuxBypassConfig
		1'b0,1'b0,1'b0,1'b1, // pe_c3_r0::MuxBConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c3_r0::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c3_r0::FuncConfig
		1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c2_r3::ConstVal
		1'b0, // pe_c2_r3::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c2_r3::MuxBypassConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c2_r3::MuxBConfig
		1'b0,1'b0,1'b0,1'b1, // pe_c2_r3::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c2_r3::FuncConfig
		1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c2_r2::ConstVal
		1'b1, // pe_c2_r2::MuxOutConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c2_r2::MuxBypassConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c2_r2::MuxBConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c2_r2::MuxAConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c2_r2::FuncConfig
		1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c2_r1::ConstVal
		1'b0, // pe_c2_r1::MuxOutConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c2_r1::MuxBypassConfig
		1'b1,1'b0,1'b0,1'b1, // pe_c2_r1::MuxBConfig
		1'b0,1'b1,1'b0,1'b1, // pe_c2_r1::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c2_r1::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c2_r0::ConstVal
		1'b0, // pe_c2_r0::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c2_r0::MuxBypassConfig
		1'b1,1'b1,1'b0,1'b0, // pe_c2_r0::MuxBConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c2_r0::MuxAConfig
		1'b1,1'b0,1'b0,1'b0, // pe_c2_r0::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c1_r3::ConstVal
		1'b1, // pe_c1_r3::MuxOutConfig
		1'b1,1'b0,1'b0, // pe_c1_r3::MuxBypassConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r3::MuxBConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r3::MuxAConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r3::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c1_r2::ConstVal
		1'b0, // pe_c1_r2::MuxOutConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r2::MuxBypassConfig
		1'b0,1'b0,1'b0,1'b1, // pe_c1_r2::MuxBConfig
		1'b1,1'b0,1'b1,1'b0, // pe_c1_r2::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c1_r2::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c1_r1::ConstVal
		1'b1, // pe_c1_r1::MuxOutConfig
		1'b0,1'b1,1'b1,1'b0, // pe_c1_r1::MuxBypassConfig
		1'b0,1'b0,1'b0,1'b1, // pe_c1_r1::MuxBConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c1_r1::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c1_r1::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c1_r0::ConstVal
		1'b1, // pe_c1_r0::MuxOutConfig
		1'b1,1'b1,1'b1, // pe_c1_r0::MuxBypassConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r0::MuxBConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r0::MuxAConfig
		1'bx,1'bx,1'bx,1'bx, // pe_c1_r0::FuncConfig
		1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx,1'bx, // pe_c0_r3::ConstVal
		1'b0, // pe_c0_r3::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c0_r3::MuxBypassConfig
		1'b1,1'b0,1'b0, // pe_c0_r3::MuxBConfig
		1'b1,1'b0,1'b1, // pe_c0_r3::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c0_r3::FuncConfig
		1'b0,1'b0,1'b0,1'b0,1'b0,1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c0_r2::ConstVal
		1'b0, // pe_c0_r2::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c0_r2::MuxBypassConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c0_r2::MuxBConfig
		1'b0,1'b0,1'b1,1'b0, // pe_c0_r2::MuxAConfig
		1'b1,1'b0,1'b0,1'b0, // pe_c0_r2::FuncConfig
		1'b0,1'b0,1'b1,1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c0_r1::ConstVal
		1'b0, // pe_c0_r1::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c0_r1::MuxBypassConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c0_r1::MuxBConfig
		1'b0,1'b1,1'b1,1'b0, // pe_c0_r1::MuxAConfig
		1'b1,1'b0,1'b0,1'b0, // pe_c0_r1::FuncConfig
		1'b0,1'b0,1'b1,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0,1'b0, // pe_c0_r0::ConstVal
		1'b0, // pe_c0_r0::MuxOutConfig
		1'bx,1'bx,1'bx, // pe_c0_r0::MuxBypassConfig
		1'b1,1'b1,1'b1,1'b0, // pe_c0_r0::MuxBConfig
		1'b0,1'b0,1'b0,1'b1, // pe_c0_r0::MuxAConfig
		1'b0,1'b0,1'b0,1'b0, // pe_c0_r0::FuncConfig
		1'bx, // mem_3::WriteRq
		1'bx,1'bx, // mem_3::MuxData
		1'bx,1'bx, // mem_3::MuxAddr
		1'bx, // mem_2::WriteRq
		1'bx,1'bx, // mem_2::MuxData
		1'bx,1'bx, // mem_2::MuxAddr
		1'bx, // mem_1::WriteRq
		1'bx,1'bx, // mem_1::MuxData
		1'bx,1'bx, // mem_1::MuxAddr
		1'b1, // mem_0::WriteRq
		1'b1,1'b0, // mem_0::MuxData
		1'b0,1'b0, // mem_0::MuxAddr
		1'bx, // io_top_3::RegOutConfig
		1'bx, // io_top_3::RegInConfig
		1'bx, // io_top_3::IOPinConfig
		1'bx, // io_top_2::RegOutConfig
		1'bx, // io_top_2::RegInConfig
		1'bx, // io_top_2::IOPinConfig
		1'bx, // io_top_1::RegOutConfig
		1'bx, // io_top_1::RegInConfig
		1'bx, // io_top_1::IOPinConfig
		1'bx, // io_top_0::RegOutConfig
		1'bx, // io_top_0::RegInConfig
		1'bx, // io_top_0::IOPinConfig
		1'b1, // drf::drfReg7Config
		1'b1, // drf::drfReg6Config
		1'bx, // drf::drfReg5Config
		1'bx, // drf::drfReg4Config
		1'b1, // drf::drfReg3Config
		1'b1, // drf::drfReg2Config
		1'bx, // drf::drfReg1Config
		1'bx, // drf::drfReg0Config
		1'b1,1'b1,1'b0, // drf::drfOutMux7Config
		1'bx,1'bx,1'bx, // drf::drfOutMux6Config
		1'b0,1'b1,1'b1, // drf::drfOutMux5Config
		1'bx,1'bx,1'bx, // drf::drfOutMux4Config
		1'bx,1'bx,1'bx, // drf::drfOutMux3Config
		1'bx,1'bx,1'bx, // drf::drfOutMux2Config
		1'b1,1'b1,1'b1, // drf::drfOutMux1Config
		1'b0,1'b1,1'b0, // drf::drfOutMux0Config
		1'b0,1'b0, // drf::drfInMux7Config
		1'b0,1'b1, // drf::drfInMux6Config
		1'bx,1'bx, // drf::drfInMux5Config
		1'bx,1'bx, // drf::drfInMux4Config
		1'b1,1'b1, // drf::drfInMux3Config
		1'b0,1'b0, // drf::drfInMux2Config
		1'bx,1'bx, // drf::drfInMux1Config
		1'bx,1'bx // drf::drfInMux0Config
	};

	reg [31:0] next_pos;
	always @(posedge clock) begin
		if (sync_reset) begin
			next_pos <= 0;
			bitstream <= 1'bx;
			done <= 0;
		end else if (next_pos >= TOTAL_NUM_BITS) begin
			done <= 1;
			bitstream <= 1'bx;
		end else if (enable) begin
			bitstream <= storage[next_pos];
			next_pos <= next_pos + 1;
		end
	end
endmodule
